public class Lib_mathmp {
public static final int MAX_VALUE = 0x7fffffff;
public static final int MIN_VALUE = 0x80000001;
public static final int E = 11134;
public static final int PI = 12868;
private static final int SIN_TABLE[] = {
  0, 71, 142, 214, 285, 357, 428, 499, 570, 641, 
  711, 781, 851, 921, 990, 1060, 1128, 1197, 1265, 1333, 
  1400, 1468, 1534, 1600, 1665, 1730, 1795, 1859, 1922, 1985, 
  2048, 2109, 2170, 2230, 2290, 2349, 2407, 2464, 2521, 2577, 
  2632, 2686, 2740, 2793, 2845, 2896, 2946, 2995, 3043, 3091, 
  3137, 3183, 3227, 3271, 3313, 3355, 3395, 3434, 3473, 3510, 
  3547, 3582, 3616, 3649, 3681, 3712, 3741, 3770, 3797, 3823, 
  3849, 3872, 3895, 3917, 3937, 3956, 3974, 3991, 4006, 4020, 
  4033, 4045, 4056, 4065, 4073, 4080, 4086, 4090, 4093, 4095, 
  4096};
private static final int etab[] = {
  4096, 11134, 30266, 0x1415e, 0x36992, 0x9469c, 0x1936dc, 0x448a21,
  0xba4f54, 0x1fa7158, 0x560a774, 0xe9e2244, 0x27bc2ca9, 0x6c02d646};


private Lib_mathmp() {}


public static int ftrunc(int i) {
  if(i<0) i -= 2048;
    else i += 2048;
  return i >> 12;
}


public static int finttoreal(int i) {
  return i << 12;
}


public static int finttoreal2(int i, int j) {
  boolean flag = false;
  if (i<0) {i=-i; flag=true;}
  i=(i << 12)+(j << 12)/10000;
  if(flag) return -i;
  return i;
}


//public static int finttoreal3(int i, int j) {
//  StringBuffer stringBuffer = new StringBuffer();
//  return fstrtoreal(stringBuffer.append(i).append('.').append(j).toString(), 10);
//}


public static int fstrtoreal(String s1, int i) {
  int j = 0;
  if(s1.charAt(0) == '-') j = 1;
  String s2 = "-1";
  int k = s1.indexOf('.');
  if(k >= 0) {
    for(s2 = s1.substring(k + 1, s1.length()); s2.length() < 4; s2 = s2 + "0");
      if(s2.length() > 4) s2 = s2.substring(0, 4);
  } else k = s1.length();
  int l = Integer.parseInt(s1.substring(j, k), i);
  int i1 = Integer.parseInt(s2, i) + 1;
  int j1 = (l << 12) + (i1 << 12) / 10000;
  if(j == 1) j1 = -j1;
  return j1;
}


public static String frealtostr(int i) {
  boolean flag = false;
  if(i < 0) {i=-i; flag = true;}
  int j = i >> 12;
  int k = 10000 * (i & 0xfff) >> 12;
  String s1;
  for(s1 = Integer.toString(k); s1.length() < 4; s1 = "0" + s1);
  return (flag ? "-" : "") + Integer.toString(j) + "." + s1;
}


public static int fdiv(int i, int j) {
  boolean flag = false;
  if(j == 0) return 0;
  if(j == 4096) return i;
  if((j & 0xfff) == 0) return i / (j >> 12);
  if(i < 0) {i=-i; flag = true;}
  if(j < 0) {j=-j; flag=!flag;}
  byte byte0 = 0;
  if(i > 0x64fff) {
    byte0 = 3;
    if(i > 0x3e8fff) {
      byte0 = 4;
      if(i > 0x7dffff) {
        byte0 = 6;
        if(i > 0x1f4ffff) {
          byte0 = 8;
          if(i > 0x7dfffff) byte0 = 10;
        }
      }
    }
    i += (1 << byte0);
    j += (1 << byte0);
  }
  int l = (i << (12 - byte0)) / (j >> byte0);
  return flag ? -l : l;
}


public static int fmul(int i, int j) {
  boolean flag = false;
  if((i & 0xfff) == 0) return (i >> 12) * j;
  if((j & 0xfff) == 0) return i * (j >> 12);
  if(i < 0) {i=-i; flag = true;}
  if(j < 0) {j=-j; flag=!flag;}
  //if(i < 0 && j > 0 || i > 0 && j < 0) flag = true;
  //if(i < 0) i = -i;
  //if(j < 0) j = -j;
  byte byte0 = 0;
  if(i > 0x64fff || j > 0x64fff) {
    byte0 = 2;
    if(i > 0x3e8fff || j > 0x3e8fff) {
      byte0 = 4;
      if(i > 0x271ffff || j > 0x271ffff) byte0 = 6;
    }
    i += (1 << byte0);
    j += (1 << byte0);
  }
  int l = ((i >> 12) * (j >> 12) << 12)+
          ((i & 0xfff) * (j & 0xfff) >> 12)+
          (((i & 0xfffff000) >> byte0) * ((j & 0xfff) >> byte0) >> 12 - (byte0 << 1))+
          (((i & 0xfff) >> byte0) * ((j & 0xfffff000) >> byte0) >> 12 - (byte0 << 1));
  if(l < 0) return 0;
  return flag ? -l : l;
}


public static int fabs(int i) {
  if(i>0) return i;
  return -i;
}


public static int fsqrt2(int i, int j) {
  if(i < 0) return 0;
  if(i == 0) return 0;
  int k = i + 4096 >> 1;
  for(int l = 0; l < j; l++) k = k + fdiv(i, k) >> 1;
  if(k < 0) return 0;
  return k;
}


public static int fsqrt(int i) {
  byte byte0 = 8;
  if(i > 0x64000) byte0 = 12;
  if(i > 0x3e8000) byte0 = 16;
  return fsqrt2(i, byte0);
}


private static int sin_lookup(int i, int j) {
  if(j > 0 && j < 10 && i < 90) return SIN_TABLE[i] + ((SIN_TABLE[i + 1] - SIN_TABLE[i]) / 10) * j;
  return SIN_TABLE[i];
}


public static int fsin(int i) {
  //for(; i < 0; i += 25736);
  while(i<0) {i+=25736;}
  if(i > 25736) i %= 25736;
  int k = (i * 10) / 714;
  int j=0;
  if(i != 0 && i != 6434 && i != 12868 && i != 19302 && i != 25736) j = (i * 100) / 714 - k * 10;
  if(k <= 90) return sin_lookup(k, j);
  if(k <= 180) return sin_lookup(180 - k, j);
  if(k <= 270) return -sin_lookup(k - 180, j);
  return -sin_lookup(360 - k, j);
}


public static int fcos(int i) {
  return fsin(i + 6435);
}


public static int ftan(int i) {
  return fdiv(fsin(i), fcos(i));
}


public static int fcotan(int i) {
  return fdiv(4096, ftan(i));
}


public static int fasin(int i) {
  boolean flag = false;
  if(i < 0) {i=-i; flag = true;}
  if(i > 4096) return 0;
  int j = 0;
  int k = SIN_TABLE.length;
  for(int l = 0; l < SIN_TABLE.length; l++) {
    int i1 = fabs(i - SIN_TABLE[l]);
    if(i1 < k) {
      k = i1;
      j = l;
    }
  }
  if(flag) return -(j*72);
  return j*72;
}


public static int facos(int i) {
  return 6434 - fasin(i);
}


public static int fexp(int i) {
  boolean flag = false;
  if(i<0) {i=-i;flag = true;}
  int l = i & 0xfff;
  i = i >> 12;
  if(i > 13) return 0;
  i = etab[i];
  if(l > 0) {
    int i1 = 0;
    int j1 = 4096;
    int k1 = 1;
    for(int l1 = 0; l1 < 6; l1++) {
      i1 += j1 / k1;
      j1 = fmul(j1, l);
      k1 *= l1 + 1;
    }
    i = fmul(i, i1);
  }
  if(flag) return fdiv(4096, i);
  return i;
}


public static int flog(int i) {
  if(i <= 0) return 0;
  int k1 = 0;
  boolean flag = false;
  int k;
  for(k = 0; i > 8192; k++) i >>= 1;
  int l = k * 2839;
  i -= 4096;
  k1=i;
  for(int j1 = 1; j1 < 11; j1++) {
    k1 = fmul(k1, i);
    if(k1 == 0) return l;
    l += ((j1 & 1)==0 ? -k1 : k1) / j1;
  }
  return l;
}


public static int flog10(int i) {
  return fdiv(flog(i), flog(2));
}


private static int pi(int i, int j) {
  int k = 4096;
  if(i == 0) return 0;
  for(int l = 0; l < j; l++) k = fmul(k, i);
  if(k < 0) return 0;
  return k;
}


public static int fpow(int i, int j) {
  boolean flag = false;
  int k = 1;
  if(j < 0) {
    flag = true;
    j = -j;
  }
  if(fabs(i) < 4096 && j > 12288) {
    k = fexp(fmul(flog(i), j));
  } else {
    k = pi(i, j >> 12);
    if((j & 0xfff) != 0)
    k = fmul(k, fexp(fmul(flog(i), j & 0xfff)));
  }
  if(flag) return fdiv(4096, k);
  return k;
}


public static int ftodegrees(int i) {
  return 180 * fdiv(i, 12868);
}


public static int ftoradians(int i) {
  return fmul(i / 180, 12868);
}


public static int fatan(int i) {
  return facos(fdiv(4096, fsqrt(1 + fmul(i, i))));
}


public static int fatan2(int i, int j) {
  if(j == 0) {
    if(i == 0) return 0;
    return i <= 0 ? -6434 : 6434;
  }
  if(j > 0) return fatan(fdiv(i, j));
  int k = 12868 - fatan(fabs(fdiv(i, j)));
  if(i >= 0) return k;
  return -k;
}

}
